<?php


/**
 * Main gallery output from playlist admin
 *
 * @param array $pargs gallery options
 * @return mixed output shortcode
 */
function dzsvg_shortcode_videogallery($pargs = array(), $content = null) {

  // -- main shortcode
  global $post;
  global $dzsvg, $dzsvg_assets;
  $fout = '';
  $iout = ''; //items parse


  $margs = array(
    'id' => 'default',
    'css_number_id' => 'default',
    'original_id' => 'default',
    'slider' => 'default',
    'extra_classes' => ' ',
    'db' => '',
    'called_from' => 'default',
    'category' => '',
    'fullscreen' => 'off',
    'output_container' => 'on',
    'call_script' => 'on',
    'init_from' => 'normal',
    'its' => '',   // -- force $its array
    'overwrite_only_its' => ''  // -- force $its array
  , 'settings_separation_mode' => 'normal'  // -- normal ( no pagination ) or "pages" or "scroll" or "button"
  , 'settings_separation_pages_number' => '5'//-- the number of items per 'page'
  , 'settings_separation_paged' => '0'//-- the page number
  , 'return_mode' => 'normal' // -- "normal" returns the whole gallery, "items" returns the items array, "parsed items" returns the parsed items ( for pagination for example )
  );

  if ($pargs == '') {
    $pargs = array();
  }

  $warningsArray = array();


  $margs = array_merge($margs, $pargs);


  if ($margs['called_from'] == 'gutenberg_playlist_render()') {

  }

  $margs['original_id'] = $margs['id'];
  if ($margs['slider'] && $margs['slider'] != 'default') {

    $margs['id'] = $margs['slider'];
  }

  if ($margs['id'] == 'auto') {


    if (isset($_GET['dzsvg_gallery_slug']) && $_GET['dzsvg_gallery_slug']) {

      $margs['id'] = $_GET['dzsvg_gallery_slug'];
    } else {

      $terms = get_terms($dzsvg->taxname_sliders, array(
        'hide_empty' => false,
      ));


      if (is_array($terms) && isset($terms[0])) {
        $margs['id'] = $terms[0]->slug;
      }
    }
  }

  if (isset($_GET['dzsvg_settings_separation_paged'])) {
    $margs['settings_separation_paged'] = $_GET['dzsvg_settings_separation_paged'];
  }

  $extra_galleries = array();

  // -- setting up the db
  $currDb = '';
  if (isset($margs['db']) && $margs['db'] != '') {
    $dzsvg->currDb = $margs['db'];
    $currDb = $dzsvg->currDb;
  }
  $dzsvg->dbs = get_option($dzsvg->dbdbsname);


  // -- *deprecated - legacy
  if ($currDb != 'main' && $currDb != '') {
    $dbitemsname = $dzsvg->dbkey_legacyItems . '-' . $currDb;
    $dzsvg->mainitems = get_option($dbitemsname);
  }
  //--setting up the db END


  if ($dzsvg->mainoptions['playlists_mode'] == 'legacy') {

    if ($dzsvg->mainitems == '') {
      return;
    }
  }

  $dzsvg->front_scripts();


  if ($margs['return_mode'] == 'normal') {
    $dzsvg->sliders_index++;
  }


  if ($margs['css_number_id'] == '' || $margs['css_number_id'] == 'default') {
    $margs['css_number_id'] = $dzsvg->sliders_index;
  }

  $i = 0;
  $k = 0;
  $id = 'default';
  if (isset($margs['id'])) {
    $id = $margs['id'];
  }


  $playlistData = array();
  // ---- extra galleries code


  $selected_term_id = '';

  $term_meta = array();

  // -- if we have its forced on us we don't need to search them again

  $reference_term_slug = '';


  if ($margs['overwrite_only_its'] && is_array($margs['overwrite_only_its'])) {
    $playlistData = $margs['overwrite_only_its'];
  } else {

    if ($margs['its'] && is_array($margs['its'])) {
      $playlistData = $margs['its'];
    } else {


      // -- playlists mode normal
      if ($dzsvg->mainoptions['playlists_mode'] == 'normal') {
        $itsForPlaylist = DzsvgView::getItsForPlaylist($margs['id']);
        $playlistData = $itsForPlaylist['its'];
        $term_meta = $itsForPlaylist['term_meta'];
      } else {
        include_once(DZSVG_PATH . 'inc/php/parse-media-apis/legacy--get-its.php');
        $playlistData = dzsvg_legacy_getItsForPlaylist($dzsvg, $margs['id']);
      }
    }
  }


  if ($margs['id'] == 'default_video_playlist') {
    $ids_arr = explode(',', $margs['ids']);

    foreach ($playlistData as $lab => $val) {
      if ($lab !== 'settings') {
        unset($playlistData[$lab]);
      }
    }

    foreach ($ids_arr as $ida) {

      $po = get_post($ida);
      $por = ClassDzsvgHelpers::sanitize_to_gallery_item($po);
      array_push($playlistData, $por);
    }
  }


  $playlistSettingsDefault = PLAYLIST_SETTINGS_DEFAULT;
  if ($dzsvg->mainoptions['playlists_mode'] == 'normal') {
    $playlistSettingsDefault['id'] = $selected_term_id;
  }

  if (isset($playlistData['settings']) && is_array($playlistData['settings'])) {
    $playlistData['settings'] = array_merge($playlistSettingsDefault, $playlistData['settings']);
  } else {
    $playlistData['settings'] = array_merge($playlistSettingsDefault, array());
  }
  if (is_array($playlistData['settings']) == false) {
    $playlistData['settings'] = array();
  }

  if ($dzsvg->mainoptions['playlists_mode'] == 'normal') {
    if ($term_meta && is_array($term_meta)) {
      foreach ($term_meta as $lab => $val) {
        if ($lab == 'autoplay_next') {
          $lab = 'autoplaynext';
        }
        $playlistData['settings'][$lab] = $val;
      }
    }


    // -- if we have reference term slug..
    $playlistData['settings']['slug'] = $reference_term_slug;
  }

  $playlistSettings = $playlistData['settings'];


  $vpsettings = array();


  $vpconfig_name = 'default';

  if (isset($playlistSettings) && isset($playlistSettings['vpconfig'])) {
    $vpconfig_name = $playlistSettings['vpconfig'];
  }


  $vpsettings = ClassDzsvgHelpers::view_getVpConfig($vpconfig_name);
  $playlistData['playerConfigSettings'] = $vpsettings['settings'];


  $playlistData['videoPlayerConfig'] = array_merge(array(), $vpsettings['settings']);
  $playlistSettings = array_merge($playlistSettings, $vpsettings['settings']);


  $playlistSettings = DzsvgView::gallerySanitizeInitialOptions($playlistSettings);


  if ($post && $dzsvg->sliders_index == 1) {
    if (get_post_meta($post->ID, 'dzsvg_preview', true) == 'on') {
      if (!is_admin()) {

        include_once(DZSVG_PATH . "class_parts/preview_page_customizer.php");
      }
    }
  }// ----dzsvg preview END


  if ($margs['category']) {

  }


  $user_feed = '';


  if ($dzsvg->mainoptions['playlists_mode'] != 'normal') {
  }

  foreach ($playlistData as $lab => $it) {

    if ($lab == 'playerConfigSettings') {
      continue;
    }

    // -- lets parse links

    if (isset($it['description'])) {

      $playlistData[$lab]['description'] = ClassDzsvgHelpers::sanitize_anchorsTextToHtml($it['description']);
    }
    if (isset($it['menuDescription'])) {
      $playlistData[$lab]['menuDescription'] = ClassDzsvgHelpers::sanitize_anchorsTextToHtml($it['menuDescription']);
    }

  }


  if (isset($playlistSettings['randomize']) && $playlistSettings['randomize'] == 'on' && is_array($playlistData)) {

    $backup_its = $playlistData;
    shuffle($playlistData);

    for ($i = 0; $i < count($playlistData); $i++) {
      if (isset($playlistData[$i]['feedfrom'])) {

        unset($playlistData[$i]);
      }
    }
    $playlistData = array_reverse($playlistData);
    $playlistSettings = $backup_its['settings'];
    $playlistData['playerConfigSettings'] = $backup_its['playerConfigSettings'];
  }


  // -- if order is descending
  if (isset($playlistSettings['order']) && $playlistSettings['order'] == 'DESC') {
    $playlistData = array_reverse($playlistData);
  }

  // --- items settled

  if ($margs['return_mode'] == 'items') {
    return $playlistData;
  }


  foreach ($extra_galleries as $extragal) {
    $args = array(
      'id' => $extragal,
      'return_mode' => 'items',
      'called_from' => 'extra_galleries',

    );


    foreach (dzsvg_shortcode_videogallery($args) as $lab => $it3) {
      if ($lab === 'settings') {
        continue;
      }
      array_push($playlistData, $it3);
    }


  }


  // ------- some sanitizing
  $tw = $playlistSettings['width'];

  $totalHeightForCss = '';


  if (isset($playlistSettings['force_height']) && $playlistSettings['force_height']) {

    $totalHeightForCss = $playlistSettings['force_height'];
  }


  if ($totalHeightForCss == '') {
    $totalHeightForCss = 'auto';
  }

  $etw = $tw;
  $eth = $totalHeightForCss;


  if (strpos($tw, "%") === false) {
    $tw = $tw . 'px';
  }

  if (strpos($totalHeightForCss, "%") === false && $totalHeightForCss != 'auto') {
    $totalHeightForCss = $totalHeightForCss . 'px';
  }

  if (isset($playlistSettings['facebooklink']) && strpos($playlistSettings['facebooklink'], "{currurl}") !== false) {
    $playlistSettings['facebooklink'] = str_replace('{currurl}', urlencode(dzs_curr_url()), $playlistSettings['facebooklink']);
  }


  if ($margs['fullscreen'] == 'on') {
    $tw = '100%';
    $totalHeightForCss = '100%';
  }


  $dzsvg->call_index--;

  if ($dzsvg->call_index < 0) {
    return $fout;
  }

  $extra_styling = '';

  $gallery_css_identifier = '.vg' . $dzsvg->sliders_index;

  if (isset($playlistSettings['skin_html5vg']) && $playlistSettings['skin_html5vg'] == 'skin-custom') {
    $extra_styling .= '<style class="dzsvg-skin-custom-styling">';
    $extra_styling .= $gallery_css_identifier . '.videogallery:not(.a):not(.a) { background:' . $dzsvg->mainoptions_dc['background'] . ';} ';
    $extra_styling .= $gallery_css_identifier . '.videogallery .navigationThumb:not(.a):not(.a){ background: ' . $dzsvg->mainoptions_dc['thumbs_bg'] . '; } ';
    $extra_styling .= $gallery_css_identifier . '.videogallery .navigationThumb.active:not(.a):not(.a),.vg' . $dzsvg->sliders_index . '.videogallery .navigationThumb:not(.a):not(.a):hover{ background-color: ' . $dzsvg->mainoptions_dc['thumbs_active_bg'] . '; } ';
    $extra_styling .= $gallery_css_identifier . '.videogallery .navigationThumb:not(.a):not(.a){ color: ' . $dzsvg->mainoptions_dc['thumbs_text_color'] . '; } .vg' . $dzsvg->sliders_index . '.videogallery .navigationThumb .the-title:not(.a):not(.a){ color: ' . $dzsvg->mainoptions_dc['thumbs_text_color'] . '; } ';

    if ($dzsvg->mainoptions_dc['thumbnail_image_width'] != '') {
      $extra_styling .= $gallery_css_identifier . '.videogallery .imgblock:not(.a):not(.a){ width: ' . $dzsvg->mainoptions_dc['thumbnail_image_width'] . 'px; } ';
    }

    if ($dzsvg->mainoptions_dc['thumbnail_image_height'] != '') {
      $extra_styling .= $gallery_css_identifier . '.videogallery .imgblock:not(.a):not(.a){ height: ' . $dzsvg->mainoptions_dc['thumbnail_image_height'] . 'px; } ';
    }

  }


  if (isset($playlistSettings) && isset($playlistSettings['extra_styling'])) {

    $extra_styling .= str_replace('{{gallery}}', $gallery_css_identifier, $playlistSettings['extra_styling']);
  }


  // ----
  // -- start output
  // ----

  if ($extra_styling) {
    $fout .= '<style class="dzsvg-skin-custom-styling">' . esc_html($extra_styling);
    $fout .= '</style>';
  }


  if ($vpsettings['settings']['skin_html5vp'] == 'skin_custom' || $vpsettings['settings']['skin_html5vp'] == 'skin_custom_aurora' || (isset($vpsettings['settings']['use_custom_colors']) && $vpsettings['settings']['use_custom_colors'] == 'on')) {
    $fout .= ClassDzsvgHelpers::style_player('.vg' . $dzsvg->sliders_index, $vpsettings);
  }


  if ($margs['output_container'] == 'on') {


    $fout .= '<div class="gallery-precon gp' . $dzsvg->sliders_index . '';
    if ($margs['fullscreen'] == 'on') {
      $fout .= ' gallery-is-fullscreen';
    }

    if ($margs['init_from'] == 'ultibox') {
      $fout .= ' show-only-in-ultibox cancel-inlinecontent-padding';
      $fout .= ' gallery-precon' . $margs['css_number_id'];
    }


    $str_h = 'auto';
    if ($margs['fullscreen'] == 'on') {
      $str_h = '100vh';
    }
    if (isset($playlistSettings['forcevideoheight']) && $playlistSettings['forcevideoheight']) {
    }
    if ($margs['fullscreen'] == 'on') {
      $tw = '100vw';
    }

    $fout .= '" style="width:' . $tw . ';height:' . $str_h . ';';


    if (isset($playlistSettings['max_width']) && $playlistSettings['max_width']) {

      $fout .= ' max-width: ' . $playlistSettings['max_width'] . 'px; margin: 0 auto; ';
    }

    if ($margs['fullscreen'] == 'on') {
      $fout .= ' position:' . 'fixed' . '; z-index:50005; top:0; left:0;';
    }
    if ($margs['category'] != '') {
      $fout .= '"';
      $fout .= '  data-category="' . $margs['category'] . '';
    }
    $fout .= '"';
    $fout .= '>';

  }


  ClassDzsvgHelpers::navigationPrepareOptions($playlistData);


  if ($margs['output_container'] == 'on') {

    if (!isset($playlistSettings['fullscreen']) || $margs['fullscreen'] != 'on') {
      $fout .= '<div class="videogallery-con';

      if (isset($playlistSettings['laptopskin']) && $playlistSettings['laptopskin'] == 'on') {
        $fout .= ' skin-laptop';
        $playlistSettings['totalheight'] = '';
        $totalHeightForCss = '';
        $playlistSettings['bgcolor'] = 'transparent';
      }


      $str_th = '';


      if ($margs['fullscreen'] == 'on') {
        $str_th = ' height: 100%;';
      }


      //-- con
      $fout .= '" style="';

      if ($tw) {
        $fout .= 'width:' . $tw . ';';
      }

      $fout .= $str_th . '">';

      if (isset($playlistSettings['laptopskin']) && $playlistSettings['laptopskin'] == 'on') {
        $fout .= '<img class="thelaptopbg" width="100%" height="100%" src="' . DZSVG_URL . 'videogallery/img/mb-body.png"/>';
      }
      $fout .= DZSVG_VIEW_PRELOADER_MARKUP;
    }
  }


  $idForClass = '';

  if (isset($playlistSettings['id']) && $playlistSettings['id']) {
    $idForClass = $playlistSettings['id'];
  } else {
    if (isset($margs['id']) && $margs['id']) {
      $idForClass = $margs['id'];
    }
  }
  if (isset($playlistSettings['slug']) && $playlistSettings['slug']) {
    $idForClass = $playlistSettings['slug'];
  }


  $viewGalleryId = DZSVideoGalleryHelper::sanitize_for_html_attribute_value_no_spaces($idForClass);


  foreach ($dzsvg->arr_api_errors as $dzsvg_error) {
    $fout .= $dzsvg_error;
  }

  $html5mp = 'right';

  if (isset($playlistSettings['menuposition'])) {

    $html5mp = $playlistSettings['menuposition'];
  }
  $isViewSearchOutside = false;


  // -- search field
  if (isset($playlistSettings['enable_search_field']) && $playlistSettings['enable_search_field'] == 'on') {

    if (isset($playlistSettings['search_field_location']) && $playlistSettings['search_field_location'] == 'inside' && $playlistSettings['displaymode'] == 'normal' && ($playlistSettings['nav_type'] == 'thumbs' || $playlistSettings['nav_type'] == 'scroller') && ($html5mp == 'left' || $html5mp == 'right')) {


    } else {
      $fout .= '<div class="vg' . $dzsvg->sliders_index . '-search-field dzsvg-search-field outer"><input type="text" placeholder="' . __('Search') . '..."/>' . $dzsvg_assets['svg_search_icon'] . '</div>';
      $isViewSearchOutside = true;
    }


  }
  // -- search field END


  $sanitizedApConfigId = ClassDzsvgHelpers::sanitizeToPhpId($playlistData['playerConfigSettings']['vpconfig_id']);


  $transition = 'fade';

  if (isset($playlistSettings['transition']) && $playlistSettings['transition']) {
    $transition = $playlistSettings['transition'];
  }

  $string_navigationSkin = 'skin-pro';

  if (isset($playlistSettings['design_skin']) && $playlistSettings['design_skin'] !== 'skin-custom') {
    $string_navigationSkin = $playlistSettings['design_skin'];
  } else {
    if (isset($playlistSettings['skin_html5vg']) && $playlistSettings['skin_html5vg'] !== 'skin-custom') {
      $string_navigationSkin = $playlistSettings['skin_html5vg'];
    }
  }

  if ($string_navigationSkin === 'skin-default') {
    if ($playlistSettings['displaymode'] === 'wall') {
      $string_navigationSkin = 'skin-wall';
    }
  }


  $playerSettingsFromGallery = array();


  if (isset($playlistSettings['set_responsive_ratio_to_detect']) && $playlistSettings['set_responsive_ratio_to_detect'] == 'on') {
    $playerSettingsFromGallery['responsive_ratio'] = 'detect';
  }

  if ($dzsvg->mainoptions['settings_trigger_resize'] == 'on') {
    $playerSettingsFromGallery['settings_trigger_resize'] = 'on';
  };


  if ($dzsvg->mainoptions['youtube_playfrom']) {
    if ($playlistSettings['feedfrom'] == 'ytuserchannel' || $playlistSettings['feedfrom'] == 'ytplaylist' || $playlistSettings['feedfrom'] == 'ytkeywords') {
      $playerSettingsFromGallery['playfrom'] = $dzsvg->mainoptions['youtube_playfrom'];
    }
  }


  if ($playlistSettings['displaymode'] == 'wall') {
    $playerSettingsFromGallery['autoplay'] = $playlistSettings['autoplay'];
  } else {
    $playerSettingsFromGallery['autoplay'] = 'off';
  }


  if ($dzsvg->mainoptions['videoplayer_end_exit_fullscreen'] == 'off') {
    $playerSettingsFromGallery['end_exit_fullscreen'] = $dzsvg->mainoptions['videoplayer_end_exit_fullscreen'];
  }

  $convertedMargs = $margs;
  $convertedMargs['randomise'] = 'off';
  $convertedMargs['settings_menu_overlay'] = 'on';
  $convertedMargs['customAttr__show_search_outside'] = $isViewSearchOutside;
  $convertedMargs['customAttr__css_classid'] = $viewGalleryId;

  if ($dzsvg->mainoptions['settings_trigger_resize'] == 'on') {
    $convertedMargs['settings_trigger_resize'] = '1000';

  };

  if ($dzsvg->mainoptions['loop_playlist'] == 'off') {
    $convertedMargs['loop_playlist'] = $dzsvg->mainoptions['loop_playlist'];

  }
  $convertedMargs['videoplayersettings'] = $sanitizedApConfigId;


  $dataOptionsArr = dzsvg_generatePlaylistSettings(array(), $playlistSettings, $convertedMargs, $playlistData);
  $dataOptions = $dataOptionsArr['string_dataOptions'];


  $audioplayerSettingsMerged = array_merge($playlistData['playerConfigSettings'], $playerSettingsFromGallery);
  $playlistItems = $playlistData;

  unset($playlistItems['playerConfigSettings']);
  unset($playlistItems['videoPlayerConfig']);
  unset($playlistItems['settings']);


  $dzsvg->vpConfigsFrontend[$sanitizedApConfigId] = dzsvg_generate_javascript_setting_for_player($audioplayerSettingsMerged)['foutArr'];


  // -- start output content
  if ($margs['output_container'] == 'on') {
    $fout .= '<div class="vg' . $dzsvg->sliders_index . ' transition-' . $transition . ' dzsvg-videogallery videogallery videogallery-' . $margs['css_number_id'] . ' auto-init id_' . $viewGalleryId . ' ' . $string_navigationSkin . ' navigation-skin--' . $string_navigationSkin;


    if (isset($playlistSettings['shadow']) && $playlistSettings['shadow'] == 'on') {
      $fout .= ' with-bottom-shadow';
    }

    if (isset($playlistSettings['extra_classes']) && $playlistSettings['extra_classes'] != '') {
      $fout .= ' ' . $playlistSettings['extra_classes'] . '';
    }


    if ($margs['fullscreen'] == 'on') {
      $fout .= ' gallery-is-fullscreen';
    }

    if ($margs['init_from'] == 'ultibox') {
      $fout .= ' auto-init-from-ultibox';
    }
    if ($totalHeightForCss && $totalHeightForCss !== 'auto') {

      $fout .= ' height-is-fixed';
    }

    $fout .= '" ';
    $fout .= ' id="' . ($viewGalleryId) . '" ';
    $fout .= ' data-dzsvg-gallery-id="' . ($viewGalleryId) . '" ';

    $fout .= ' data-options=\'' . $dataOptions . '\' ';


    $fout .= '';


    $fout .= '   style=\'';


    if (isset($playlistSettings['skin_html5vg']) && $playlistSettings['skin_html5vg'] != 'skin-custom') {
      $fout .= 'background-color:' . $playlistSettings['bgcolor'] . ';';
    }

    if ($totalHeightForCss && $totalHeightForCss !== 'auto') {

      $fout .= '  height:' . $totalHeightForCss . ';';
    }
    $fout .= '\'';
    $fout .= '>';

    if ($dzsvg->mainoptions['use_layout_builder_on_navigation'] == 'on') {
      if ($dzsvg->classLayoutBuilder_menuItems) {
        $fout .= $dzsvg->classLayoutBuilder_menuItems->get_frontend_struct($string_navigationSkin);
        $fout .= '<style>' . $dzsvg->classLayoutBuilder_menuItems->get_frontend_css() . '</style>';
      }
    }


    if ($playlistSettings['displaymode'] === 'wall') {

      // todo: layout builder
      $fout .= '<div hidden class="feed-layout-builder--menu-items"><div class="layout-builder--structure  layout-builder--main-con ">
  <div class="layout-builder--item layout-builder--item--11241412321 layout-builder--item--type-container" style="padding-top: 75%;">
    <div class="layout-builder--item layout-builder--item--2312321 layout-builder--item--type-thumbnail navigation-type-image" style="background-image: url({{layout-builder.replace-thumbnail-url}}); width: calc(100% + 20px);
    height: calc(100% + 9px);
    position: absolute;
    top: 0;
    left: 0;
    margin-left: -10px;
    margin-top: -10px;
}"></div>
  </div>
  <div class="layout-builder--item layout-builder--item--11241412321 layout-builder--item--type-container">
    <div class="layout-builder--item layout-builder--item--3321321 layout-builder--item--type-title" style=";">{{layout-builder.replace-title}}</div>
    <div class="layout-builder--item layout-builder--item--21312321 layout-builder--item--type-menu-description" style=";">{{layout-builder.replace-menu-description}}</div>
  </div>
</div></div>';
    }


    $fout .= '<div class="items">';
  }


  $iout .= $dzsvg->classView->parse_items($playlistData, $margs);

  $fout .= $iout;


  if ($iout == '') {
    array_push($warningsArray, array(
      'warning_type' => 'warning',
      'warning_content' => esc_html__("Gallery", DZSVG_ID) . ' <strong>' . $margs['id'] . '</strong> ' . esc_html__("does not seem to have any videos.", DZSVG_ID),
    ));
  }

  if ($content) {

    // -- sanitize..
    $content = str_replace('&#8221;', '"', $content);
    $content = str_replace('&#8217;', '"', $content);
    $content = str_replace('&#8243;', '"', $content);
    $fout .= do_shortcode(($content));

  }


  $fout .= '</div><!-- end .items-->'; // -- end .items


  foreach ($dataOptionsArr['extraFeedOptions'] as $key => $val) {
    $fout .= '<script type="text/html" hidden class=" feed-dzsvg ' . $key . '">' . $val . '</script>';
  }

  $socialCode = '';

  if (isset($playlistSettings['sharebutton'])) {
    $socialCode = $dzsvg->classView->generateShareCode($playlistSettings['sharebutton'], $playlistSettings);
  }

  if ($socialCode) {
    $fout .= '<div hidden class="feed-dzsvg feed-dzsvg--socialCode">' . $socialCode . '</div>';
  }

  if (!isset($playlistSettings['fullscreen']) || $playlistSettings['fullscreen'] != 'on') {
    $fout .= '</div>';// -- <!-- end .videogallery -->
  }


  $fout .= '</div>';


  $script_final = '';
  if ($margs['call_script'] == 'on') {


    if ($margs['init_from'] == 'ultibox') {

      $dzsvg->script_footer_root .= '';
    } else {
      $dzsvg->script_footer_root .= '';
    }


    // -- end custom settings


    $dzsvg->script_footer_root .= '';


    if ($playlistSettings['displaymode'] == 'wall') {


      $dzsvg->script_footer_root .= 'window.ultibox_videoplayersettings = "' . $sanitizedApConfigId . '";';
      $dzsvg->script_footer_root .= 'window.ultibox_options_init = { videoplayer_settings : "' . $sanitizedApConfigId . '"} ;';


      // in wall we need dzsap
      wp_enqueue_style('dzsap', DZSVG_URL . 'libs/audioplayer/audioplayer.css');
      wp_enqueue_script('dzsap', DZSVG_URL . 'libs/audioplayer/audioplayer.js');


      wp_enqueue_script('jquery.masonry', DZSVG_URL . "assets/masonry/jquery.masonry.min.js");


      ClassDzsvgHelpers::enqueueUltibox();

    }


    // --- here we had a jq ready call


    // -- end vpsettings


    $options_array_string = '';


    if (isset($playlistSettings['action_playlist_end']) && $playlistSettings['action_playlist_end']) {
      $script_final .= '
                        setTimeout(function(){ function gotonext_' . ClassDzsvgHelpers::sanitize_forHtmlClass($playlistSettings['id']) . '(arg){
//console.info($(\'.id_' . $viewGalleryId . '\'));

                                ' . stripslashes($playlistSettings['action_playlist_end']) . '
                            }
console.info("$(\'.id_' . $viewGalleryId . '\') -> ",$(\'.id_' . $viewGalleryId . '\'));
                            $(\'.id_' . $viewGalleryId . '\').get(0).api_set_action_playlist_end(gotonext_' . ClassDzsvgHelpers::sanitize_forHtmlClass($playlistSettings['id']) . ');
                        },1000);';
    }


    if ($margs['init_from'] == '' || $margs['init_from'] == 'normal') {
      $dzsvg->script_footer .= $script_final;
    }
    if ($margs['init_from'] == 'ultibox') {
      $fout .= '<div class="dzs--to-execute toexecute to-execute--from-ultibox">' . $dzsvg->script_footer_root . $script_final . '</div>';
    }
  }

  $fout .= '<div class="clear"></div>';

  if ($margs['settings_separation_mode'] == 'pages') {
    $fout .= '<div class="con-dzsvg-pagination">';


    $numberOfPages = ceil(count($playlistItems) / intval($margs['settings_separation_pages_number']));

    if ($numberOfPages > 1) {
      for ($i = 0; $i < $numberOfPages; $i++) {
        $str_active = '';
        if (($i + 1) == $margs['settings_separation_paged']) {
          $str_active = ' active';
        };

        $curr_url = dzs_curr_url();
        if ($post) {
          if (get_permalink($post->ID)) {

            $curr_url = get_permalink($post->ID);
          }
        }

        $auxurl = add_query_arg(array('dzsvg_settings_separation_paged' => ($i + 1)), $curr_url);


        $fout .= '<a class="pagination-number ' . $str_active . '" href="' . esc_url($auxurl) . '">' . ($i + 1) . '</a>';
      }

    }
    $fout .= '</div>';
  }

  $fout .= '</div>';
  // -- END gallery-precon


  if (isset($playlistSettings['enableunderneathdescription']) && $playlistSettings['enableunderneathdescription'] == 'on') {

    $fout .= dzsvg_view_generateSecondConForUnderneathGallery($dzsvg->sliders_index, $playlistData);
  }


  if ($playlistSettings['displaymode'] == 'wall') {
    wp_enqueue_script('jquery.masonry', DZSVG_URL . "assets/masonry/jquery.masonry.min.js");


    ClassDzsvgHelpers::enqueueUltibox();
  }


  // -- alternatewall
  // ---- mode alternatewall


  if ($playlistSettings['displaymode'] == 'alternatewall') {
    $fout = '';
    $fout .= '<style>
.dzs-gallery-container .item{ width:23%; margin-right:1%; float:left; position:relative; display:block; margin-bottom:10px; }
.dzs-gallery-container .item-image{ width:100%; }
.dzs-gallery-container h4{  color:#D26; }
.dzs-gallery-container h4:hover{ background: #D26; color:#fff; }
.last { margin-right:0!important; }
.clear { clear:both; }
</style>';
    $fout .= '<div class="dzs-gallery-container">';


    $fout .= $dzsvg->classView->parse_items($playlistData, $margs);


    $fout .= '<div class="clear"></div>';
    $fout .= '</div>';


    if ($margs['settings_separation_mode'] == 'pages') {
      $fout .= '<div class="con-dzsvg-pagination">';


      for ($i = 0; $i < ceil(count($playlistData) / intval($margs['settings_separation_pages_number'])); $i++) {
        $str_active = '';
        if (($i + 1) == $margs['settings_separation_paged']) {
          $str_active = ' active';
        }
        $fout .= '<a class="pagination-number ' . $str_active . '" href="' . esc_url(add_query_arg(array('dzsvg_settings_separation_paged' => ($i + 1)), dzs_curr_url())) . '">' . ($i + 1) . '</a>';
      }
      $fout .= '</div>';
    }

    $fout .= '<div class="clear"></div>';


    // todo: zoombox to ultibox here
//            $fout .= '<script>jQuery(document).ready(function($){ jQuery(".zoombox").zoomBox(); });</script>';


    ClassDzsvgHelpers::enqueueUltibox();

    return $fout;
  }


  // -- alternate menu
  /////---mode alternatemenu
  if ($playlistSettings['displaymode'] == 'alternatemenu') {
    include_once(DZSVG_PATH . 'inc/php/deprecated/alternate-menu-functions.php');
    $fout = dzsvg_altenate_menu_output($playlistData);
  }

  if ($dzsvg->mainoptions['debug_mode'] == 'on') {
    $fout .= '<div class="dzstoggle toggle1" rel="">
<div class="toggle-title" style="">' . __('memory usage - ', DZSVG_ID) . '</div>
<div class="toggle-content">';
    $fout .= 'memory usage - ' . memory_get_usage() . "\n <br>memory limit - " . ini_get('memory_limit');
    $fout .= '</div></div>';

  }


  if ($dzsvg->mainoptions['analytics_enable'] == 'on') {

    if (current_user_can('manage_options')) {

      $fout .= '<div class="extra-btns-con">';
      $fout .= '<span class="btn-zoomsounds stats-btn" data-playerid="' . '' . '"><span class="the-icon"><i class="fa fa-tachometer" aria-hidden="true"></i></span><span class="btn-label">Stats</span></span>';
      $fout .= '</div>';


      ClassDzsvgHelpers::enqueueDzsVgShowcase();
    }


  }

  ClassDzsvgHelpers::enqueueDzsVgPlaylist();

  $fout .= dzs_parseWarningsArrayToHtml($warningsArray);

  if ($margs['return_mode'] != 'parsed items') {
    $fout = str_replace('https://img.youtube.com', '//img.youtube.com', $fout);
    return $fout;
  }

  $iout = str_replace('https://img.youtube.com', '//img.youtube.com', $iout);
  return $iout;


}

