<?php
/*
  Plugin Name: DZS Video Gallery
  Plugin URI: https://digitalzoomstudio.net/
  Description: Creates and manages cool video galleries. Has a admin panel and tons of options and skins.
  Version: 12.16
  Author: Digital Zoom Studio
  Author URI: https://digitalzoomstudio.net/
 */


const DZSVG_VERSION = '12.16';

define('DZSVG_PATH', dirname(__FILE__) . '/');
if (function_exists('plugin_dir_url')) {
  define('DZSVG_URL', plugin_dir_url(__FILE__));
}
include_once(DZSVG_PATH . 'configs/php-constants.php');


include_once(DZSVG_PATH . 'dzs_functions.php');
if (!class_exists('DZSVideoGallery')) {
  include_once(DZSVG_PATH . 'class-dzsvg.php');
}

$dzsvg = new DZSVideoGallery();


if (isset($dzsvg->mainoptions['enable_cs']) && $dzsvg->mainoptions['enable_cs'] == 'on') {
  // -- CornerStone
  add_action('wp_enqueue_scripts', 'dzsvg_enqueue');
  add_action('cornerstone_register_elements', 'dzsvg_register_elements');
  add_filter('cornerstone_icon_map', 'dzsvg_icon_map');
  add_action('_cornerstone_home_before', 'dzsvg_home_before');
  add_action('cornerstone_before_wp_editor', 'dzsvg_home_before');
  add_action('cornerstone_load_builder', 'dzsvg_home_before');


  /**
   * enqueue in customizer
   */
  function dzsvg_home_before() {

    wp_enqueue_script('dzsvg-admin-for-cornerstone', DZSVG_URL . 'assets/admin/admin-for-cornerstone.js', array('jquery'));
    wp_enqueue_script('dzsvg-admin-global', DZSVG_URL . 'admin/admin_global.js', array('jquery'));
    wp_enqueue_style('dzsvg-admin-global', DZSVG_URL . '/admin/admin_global.css');

  }

  function dzsvg_register_elements() {
    if (function_exists('cornerstone_register_element')) {
      cornerstone_register_element('CS_DZSVG', 'dzsvg', DZSVG_PATH . 'inc/cornerstone/dzsvg');
      cornerstone_register_element('CS_DZSVG_PLAYLIST', 'dzsvg_playlist', DZSVG_PATH . 'inc/cornerstone/dzsvg_playlist');
    }
  }

  function dzsvg_enqueue() {
    global $dzsvg;
    $dzsvg->enqueue_main_scripts();
  }

  function dzsvg_icon_map($icon_map) {
    $icon_map['dzsvg'] = DZSVG_URL . '/assets/svg/icons.svg';
    return $icon_map;
  }
}


if (!function_exists('dzsvg_handle_activated_plugin')) {
  function dzsvg_handle_activated_plugin($plugin = '') {
    $isRedirect = false;
    if ($plugin == plugin_basename(__FILE__)) {
      if (!get_option('dzsvg_shown_intro')) {
        $isRedirect = true;
      }
    }
    if (defined('DZSVG_PREVIEW') && DZSVG_PREVIEW == 'YES') {
      $isRedirect = true;
    }


    if ($isRedirect) {

      exit(wp_redirect(admin_url('admin.php?page=dzsvg-about')));
    }
  }
}


if (defined('DZSVG_PREVIEW') && DZSVG_PREVIEW == "YES") {
  add_action('wp_login', 'dzsvg_handle_activated_plugin', 10, 2);
}


add_action('activated_plugin', 'dzsvg_handle_activated_plugin');
register_activation_hook(__FILE__, array($dzsvg, 'handle_plugin_activate'));
register_deactivation_hook(__FILE__, array($dzsvg, 'handle_plugin_deactivate'));


if (isset($dzsvg->mainoptions['enable_widget']) && $dzsvg->mainoptions['enable_widget'] == 'on' && file_exists($dzsvg->base_path . 'widget.php')) {
  include_once('widget.php');
}


